import { Color } from "./engine/datatypes.ts";
import { Stat } from "./datatypes.ts";

export class ColorSystem {
  readonly BG_INSET = Color.parseHexCode("#242234");
  readonly FG_TEXT = Color.parseHexCode("#c0c0c0");
  readonly FG_TEXT_DISABLED = Color.parseHexCode("#808080");
  readonly FG_TOO_EXPENSIVE = Color.parseHexCode("#ff8080");
  readonly FG_TEXT_ENDORSED = Color.parseHexCode("#80ff80");
  readonly FG_BOLD = Color.parseHexCode("#ffffff");
  readonly BG_OUTER = Color.parseHexCode("#143464");
  readonly BG_WALL_OR_UNREVEALED = Color.parseHexCode("#143464");
  readonly BG_CEILING = Color.parseHexCode("#143464");

  // stat colors
  readonly SWATCH_EXP: [Color, Color] = [
    Color.parseHexCode("#b9bffb"),
    Color.parseHexCode("#e3e6ff"),
  ];

  readonly SWATCH_AGI: [Color, Color] = [
    Color.parseHexCode("#df3e23"),
    Color.parseHexCode("#fa6a0a"),
  ];

  readonly SWATCH_INT: [Color, Color] = [
    Color.parseHexCode("#285cc4"),
    Color.parseHexCode("#249fde"),
  ];

  readonly SWATCH_CHA: [Color, Color] = [
    Color.parseHexCode("#793a80"),
    Color.parseHexCode("#bc4a9b"),
  ];

  readonly SWATCH_PSI: [Color, Color] = [
    Color.parseHexCode("#9cdb43"),
    Color.parseHexCode("#d6f264"),
  ];

  readonly SWATCH_STAT: Record<Stat, [Color, Color]> = {
    AGI: this.SWATCH_AGI,
    INT: this.SWATCH_INT,
    CHA: this.SWATCH_CHA,
    PSI: this.SWATCH_PSI,
  };
}

export let C = new ColorSystem();
